#pragma once
#include "stdafx.h"
#include "BinaryMapReader.h"


using namespace std;



BinaryMapReader::BinaryMapReader() {
	w = -1;
	h = -1;
	num_frames = 0;
	file = NULL;
}


BinaryMapReader::~BinaryMapReader() {
	if(file) {
		fclose(file);
	}
}


void BinaryMapReader::clear() {
	if(file != NULL) {
		fclose(file);
		file = NULL;
		w = -1;
		h = -1;
		num_frames = 0;
	}
}


bool BinaryMapReader::read(const TCHAR *filepath) {

	if(filepath == NULL) return false;

	clear();

	file = _tfopen(filepath, _T("rb"));

	if(file != NULL) {
		fscanf(file, "%d %d %d", &w, &h, &num_frames);
		return true;
	}
	else {
		return false;
	}
}


int BinaryMapReader::getWidth() {
	return w;
}


int BinaryMapReader::getHeight() {
	return h;
}


int BinaryMapReader::getNumFrames() {
	return num_frames;
}


void BinaryMapReader::getDimension(int &width, int &height) {
	width = w;
	height = h;
}


bool BinaryMapReader::load(int frame, unsigned char *bin_map) {
	int num_pixels;
	int dum[3];
	unsigned char dum2;
	long offset = 0;


	if(bin_map == NULL || file == NULL) return false;

	num_pixels = w * h;

	if(0 <= frame && frame < num_frames) {
		fseek(file, 0, SEEK_SET);

		// read header again...
		fscanf(file, "%d %d %d", &(dum[0]), &(dum[1]), &(dum[2]));
		fread(&dum2, sizeof(char), 1, file);

		offset = frame * num_pixels * sizeof(unsigned char);

		fseek(file, offset, SEEK_CUR);
		fread(bin_map, sizeof(unsigned char), num_pixels, file);
	}
	else {
		for(int i = 0; i < num_pixels; i++) bin_map[i] = 0;
	}

	return true;
}
