#pragma once
#include "image_pyramid.h"
#include <list>

using namespace std;


class EdgeFieldConstructor {
public:
	const static int temporal_kernel_size = 5;
	const static int spatial_kernel_size = 5;
	const static double gaussian1D[];		// element size is 5 (same as kernel size for temporal and spatial blur)

public:
	bool computeEdgeField(unsigned char *(&img), FieldSampleImage &fsi, int num_blur);
	bool refineEdgeField(FieldSampleImage &target, const FieldSampleImage &src, float angle_constraint_radian, bool recompute_vector = false);
	bool averageEdgeField_S(FieldSampleImage &fsi, bool recompute_vector = false);
	bool averageEdgeField_T(const list<FieldSampleImage *> &fsi_list, FieldSampleImage &out, bool recompute_vector = false);

private:
	void addPadding(const FieldSampleImage *in, FieldSampleImage *out);
};