#pragma once
#include "GLSplineFactory.h"



GLSplineFactory::~GLSplineFactory() {
	list<GLSpline*>::iterator itr, end = recycled.end();

	for(itr = recycled.begin(); itr != end; itr++) delete *itr;
}

GLSpline* GLSplineFactory::make(float x0, float y0, float width, float *color, float angle, bool use_texture) {
	GLSpline *spline = NULL;

	if(recycled.empty() == false) {
		spline = recycled.front();
		recycled.pop_front();
		spline->reset(x0, y0, width, color, angle, use_texture);
	}
	else{
		spline = new GLSpline(x0, y0, width, color, angle, use_texture);
	}

	return spline;
}


void GLSplineFactory::dump(list<GLSpline*> &spline_list) {
	recycled.splice(recycled.end(), spline_list, spline_list.begin(), spline_list.end());
}


void GLSplineFactory::hold(int size) {
	int current_size = (int)recycled.size();

	while(current_size <= size && recycled.empty() == false) {
		delete recycled.front();
		recycled.pop_front();
		current_size--;
	}
}


int GLSplineFactory::getSize() {
	return (int)recycled.size();
}

