#pragma once
#include "StrokeComparator.h"
#include "VisView.h"
#include <utility>
#include "afxwin.h"

using namespace std;


// HSVOptionDlg dialog

class HSVOptionDlg : public CDialog
{
	DECLARE_DYNAMIC(HSVOptionDlg)
	CWnd *parent;
	VisView *visview;

public:
	HSVOptionDlg(VisView *pVisview, CWnd* pParent = NULL);   // standard constructor
	virtual ~HSVOptionDlg();

// Dialog Data
	enum { IDD = IDD_HSV_ORDERING };

	static const pair<LPCSTR, HSVComparator::FUNC_TYPE> h_func_type[];
	static const pair<LPCSTR, HSVComparator::FUNC_TYPE> s_func_type[];
	static const pair<LPCSTR, HSVComparator::FUNC_TYPE> v_func_type[];
	static const pair<LPCSTR, HSVComparator::EVAL_ORDER> eval_type[];
	static const pair<LPCSTR, float> huebreak_selection[];


protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
	virtual void OnOK();
	virtual void OnCancel();

public:
	virtual BOOL OnInitDialog();
	afx_msg void OnCbnSelchangeHFunc();
	afx_msg void OnCbnSelchangeSFunc();
	afx_msg void OnCbnSelchangeVFunc();
	afx_msg void OnCbnSelchangeHsvEvalOrder();
	afx_msg void OnEnKillfocusHueBreak();
	afx_msg void OnDeltaposHueBreakSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnCbnSelchangeHueBreakCombo();

private:
	CComboBox hue_selection_combo;
};
