#pragma once
#include <vector>
#include <utility>

using namespace std;


class PathMaker {
public:
	static const enum MODE {
		FREEFORM, 
		CIRCLE, 
		SQUARE, 
		LINE, 
	};

private:
	int x0, y0;
	vector< pair<int, int> >  *points;
	PathMaker::MODE mode;


public:
	PathMaker();
	virtual ~PathMaker();

	
	void setMode(PathMaker::MODE new_mode);
	PathMaker::MODE getMode();

	void start(int x0, int y0);
	void update(int x, int y);

	void getCenter(pair<int, int> &center);
	void setPathContainer(vector< pair<int, int> >  &container);
	void releasePathContainer();
};