// RGBOptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCTEST4.h"
#include "RGBOptionDlg.h"
#include "TabContent1.h"
#include ".\rgboptiondlg.h"



typedef pair<LPCSTR, RGBComparator::FUNC_TYPE> ft_pair;

const ft_pair RGBOptionDlg::func_type[] = {
	ft_pair(_T("Max."), RGBComparator::MAX), 
	ft_pair(_T("Min."), RGBComparator::MIN), 
};



// RGBOptionDlg dialog

IMPLEMENT_DYNAMIC(RGBOptionDlg, CDialog)
RGBOptionDlg::RGBOptionDlg(VisView *pVisview, CWnd* pParent /*=NULL*/)
	: CDialog(RGBOptionDlg::IDD, pParent)
{
	parent = pParent;
	visview = pVisview;
}

RGBOptionDlg::~RGBOptionDlg() {}

void RGBOptionDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(RGBOptionDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_RGB_FUNC, OnCbnSelchangeRgbFunc)
END_MESSAGE_MAP()


// RGBOptionDlg message handlers

void RGBOptionDlg::OnCancel() {
	CDialog::OnCancel();
}


BOOL RGBOptionDlg::OnInitDialog() {
	CComboBox *box;

	CDialog::OnInitDialog();

	box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_RGB_FUNC));
	box->AddString(func_type[0].first);
	box->AddString(func_type[1].first);

	for(int i = 0; i < 2; i++) {
		if(StrokeComparator::rgb_comp.getEvalFunc() == func_type[i].second) {
			box->SetCurSel(i);
			break;
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void RGBOptionDlg::OnCbnSelchangeRgbFunc() {
	CComboBox *box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_RGB_FUNC));
	StrokeComparator::rgb_comp.setEvalFunc(func_type[box->GetCurSel()].second);

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}


void RGBOptionDlg::OnOK() {
	CDialog::OnOK();
}
