#pragma once
#include "StdAfx.h"
#include "Segmentation.h"

Segmentation::Segmentation(void)
: RegionID(NULL)
, regionIdDefined(false)
, image_width(512)
, image_height(512)
//, SegImg(NULL)
{
}

Segmentation::~Segmentation(void)
{
}

void Segmentation::getSegImage(unsigned char* original_img, unsigned char* seg_img, int img_width, int img_height, float Range, int Spatial, int minRegion)
{
	//Define Image
	//img.DefineImage(original_img,COLOR,img_width,img_height);
	img.DefineImage(original_img,COLOR,image_width,image_height);
	
	//Segment the image
	img.Segment(Spatial,Range,minRegion,MED_SPEEDUP);
	//Get the result
	img.GetResults(seg_img);
	setPara(image_width,image_height);
	setRegionID(seg_img,image_width,image_height);

}

void Segmentation::setRegionID(unsigned char* seg_img, int img_w, int img_h)
{
	unsigned int color_id;
    img_w=512;
	img_h=512;
	if(RegionColor_R.size()!=0)
	{
		RegionColor_R.clear();
		RegionColor_G.clear();
		RegionColor_B.clear();
	}
	if(regionIdDefined) delete [] RegionID;
	RegionID = new unsigned int [img_w*img_h];
    for(int i=0;i<img_h;i++)
	{
		for(int j=0;j<img_w;j++)
		{
			unsigned int pixel;
			pixel=j + i * img_w;
			unsigned char r=seg_img[3 * pixel];
            unsigned char g=seg_img[3 * pixel+1];
			unsigned char b=seg_img[3 * pixel+2];

			for(color_id=0;color_id<RegionColor_R.size();color_id++)
			{
				if((r==RegionColor_R[color_id])&&(g==RegionColor_G[color_id])&&(b==RegionColor_B[color_id]))
				{
					RegionID[pixel]=color_id;
					break;
				}
			}
			if(color_id==RegionColor_R.size())
			{
				

				RegionColor_R.push_back(r);
				RegionColor_G.push_back(g);
				RegionColor_B.push_back(b);
                RegionID[pixel]=color_id;
			}
		}
	}
		

	
	regionIdDefined = true;
}

int Segmentation::getRegionID(int x, int y)
{

	return RegionID[x+y*image_width];
}

void Segmentation::setPara(int w, int h)
{
	/*image_width=w;
	image_height=h;*/
	image_width=512;
	image_height=512;
}

void Segmentation:: merge(unsigned char* seg_img,unsigned int mergeRegion1, unsigned int mergeRegion2)
{
	unsigned char mergeColor1_R;
	unsigned char mergeColor1_G;
	unsigned char mergeColor1_B;
	unsigned char mergeColor2_R;
	unsigned char mergeColor2_G;
	unsigned char mergeColor2_B;
	unsigned char mergeColor_R;
	unsigned char mergeColor_G;
	unsigned char mergeColor_B;

    //get 1,2 color
	mergeColor1_R=RegionColor_R[mergeRegion1];
    mergeColor1_G=RegionColor_G[mergeRegion1];
	mergeColor1_B=RegionColor_B[mergeRegion1];

	mergeColor2_R=RegionColor_R[mergeRegion2];
    mergeColor2_G=RegionColor_G[mergeRegion2];
	mergeColor2_B=RegionColor_B[mergeRegion2];

	//get merge color
	mergeColor_R=(mergeColor1_R+mergeColor2_R)/2;
	mergeColor_G=(mergeColor1_G+mergeColor2_G)/2;
	mergeColor_B=(mergeColor1_B+mergeColor2_B)/2;

	//set the color to the two region in seg image
	for(int y=0;y<image_height;y++)
	{
		for(int x=0;x<image_width;x++)
		{
			unsigned int pixel;
			pixel=x + y * image_width;
			if(RegionID[pixel]==mergeRegion1 || RegionID[pixel]==mergeRegion2)
			{
				seg_img[3 * pixel]=mergeColor_R;
                seg_img[3 * pixel+1]=mergeColor_G;
			    seg_img[3 * pixel+2]=mergeColor_B;	

			}
		}
	}

	//get the region id again
	setRegionID(seg_img,image_width,image_height);

}
