#include "StdAfx.h"
#include "ShaderObject.h"

ShaderObject::ShaderObject(const string &NewFileName, SHADERTYPE NewShaderType)
{
	FileName	= NewFileName;
	Type		= NewShaderType;
	hShader     = 0;
}
ShaderObject::~ShaderObject()
{

}
void ShaderObject::Compile()
{
	if(FileName == "")
		return;

	if(Type == VS)
		hShader = glCreateShader(GL_VERTEX_SHADER);
	else if(Type == PS)
		hShader = glCreateShader(GL_FRAGMENT_SHADER);

	string FullPath = ToString("Shaders/") + FileName;
	const char * str = textFileRead((char*)FullPath.c_str());

	if(!str)
	{
		FullPath = ToString("../Shaders/") + FileName;
		str = textFileRead((char*)FullPath.c_str());
	}

	if(!str)
	{
		printf("Failed to find shader file %s. Compile Failure", FileName.c_str());
		return;
	}
	glShaderSource(hShader, 1, &str,NULL);
	free((void*)str);

	glCompileShader(hShader);
}