#pragma once


// Brush stoke properties... new properties could be added later.
typedef struct SimpleStroke {
	float x, y, z;							// in Cartesian coordinates
	float stroke_jitter_shift[3];		// stroke color jittering value
	int jitter_id;						// reference to inner stroke jitter pattern
	int lifetime;
	bool valid;
	unsigned int id;
	float size;							// size == diameter in pixels
	int depth;

	unsigned char color[4];
	float hsv[3];
	float angle;						// orientation

	SimpleStroke(unsigned int id) {
		this->id = id;
		reset();
	}

	void reset() {
		x = 0;
		y = 0;
		z = 0;
		jitter_id = -1;
		lifetime = 0;
		valid = true;
		size = 1.f;
		depth = 0;

		stroke_jitter_shift[0] = 0;
		stroke_jitter_shift[1] = 0;
		stroke_jitter_shift[2] = 0;

		angle = 0;
	}

} SimpleStroke;
