#pragma once
#include "SimpleStrokeFactory.h"



SimpleStrokeFactory::~SimpleStrokeFactory() {
	list<SimpleStroke*>::iterator itr, end = recycled.end();

	for(itr = recycled.begin(); itr != end; itr++) delete *itr;
}

SimpleStroke* SimpleStrokeFactory::make(int id) {
	SimpleStroke *stroke = NULL;

	if(recycled.empty() == false) {
		stroke = recycled.front();
		recycled.pop_front();
		stroke->id = id;
		stroke->reset();
	}
	else{
		stroke = new SimpleStroke(id);
	}

	return stroke;
}


void SimpleStrokeFactory::dump(list<SimpleStroke*> &stroke_list) {
	recycled.splice(recycled.end(), stroke_list, stroke_list.begin(), stroke_list.end());
}


void SimpleStrokeFactory::dump(SimpleStroke *stroke) {
	recycled.push_back(stroke);
}


void SimpleStrokeFactory::hold(int size) {
	int current_size = (int)recycled.size();

	while(current_size <= size && recycled.empty() == false) {
		delete recycled.front();
		recycled.pop_front();
		current_size--;
	}
}


int SimpleStrokeFactory::getSize() {
	return (int)recycled.size();
}

