// TabContent0.cpp : implementation file
//

#pragma once
#include "stdafx.h"
#include "TabContent0.h"
#include ".\tabcontent0.h"


// TabContent0 dialog

IMPLEMENT_DYNAMIC(TabContent0, CDialog)


TabContent0::TabContent0(CMFCTEST4Dlg* pParent)
	: CDialog(TabContent0::IDD, pParent)
{
	ASSERT(pParent != NULL);
	Create(IDD, pParent);
	this->parent = pParent;
	initializeValues();
}


const int TabContent0::init_global_rotation_val = 0;
const int TabContent0::global_rotation_range[] = {0, 360};

const double TabContent0::init_weight_interpolation = 0.5;
const double TabContent0::weight_interpolation_range[] = {0., 1.};

const int TabContent0::init_edge_field_smoothing_val = 40;
const int TabContent0::edge_field_smoothing_range[] = {0, 500};

const int TabContent0::init_img_smoothing_for_edgefield_range = 7;
const int TabContent0::img_smoothing_for_edgefield_range[2] = {0, 100};


TabContent0::~TabContent0()
{
}

void TabContent0::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(TabContent0, CDialog)
	ON_EN_KILLFOCUS(IDC_EDGE_FIELD_SMOOTHING, OnEnKillfocusEdgeFieldSmoothing)
	ON_NOTIFY(UDN_DELTAPOS, IDC_EDGE_FIELD_SMOOTHING_SPIN, OnDeltaposEdgeFieldSmoothingSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_GLOBAL_ROTATION_SPIN, OnDeltaposGlobalRotationSpin)
	ON_EN_KILLFOCUS(IDC_GLOBAL_ROTATION, OnEnKillfocusGlobalRotation)
	ON_BN_CLICKED(IDC_ADD_REGULAR_ELEMENT, OnBnClickedAddRegularElement)
	ON_BN_CLICKED(IDC_ADD_SOURCE, OnBnClickedAddSource)
	ON_BN_CLICKED(IDC_ADD_SINK, OnBnClickedAddSink)
	ON_BN_CLICKED(IDC_ADD_CCW_CENTER, OnBnClickedAddCcwCenter)
	ON_BN_CLICKED(IDC_ADD_CW_CENTER, OnBnClickedAddCwCenter)
	ON_BN_CLICKED(IDC_ADD_SADDLE, OnBnClickedAddSaddle)
	ON_BN_CLICKED(IDC_ADD_DIPOLE1, OnBnClickedAddDipole1)
	ON_BN_CLICKED(IDC_ADD_DIPOLE2, OnBnClickedAddDipole2)
	ON_BN_CLICKED(IDC_ADD_MONKEY_SADDLE, OnBnClickedAddMonkeySaddle)
	ON_BN_CLICKED(IDC_EDIT_ELEMENT, OnBnClickedEditElement)
	ON_BN_CLICKED(IDC_REMOVE_ELEMENT, OnBnClickedRemoveElement)
	ON_BN_CLICKED(IDC_FLOW_SMOOTHING, OnBnClickedFlowSmoothing)
	ON_BN_CLICKED(IDC_SINGULARITY_PAIR_CANCELLATION, OnBnClickedSingularityPairCancellation)
	ON_BN_CLICKED(IDC_MOVE_SINGULARITY, OnBnClickedMoveSingularity)
	ON_BN_CLICKED(IDC_SET_ZERO, OnBnClickedSetZero)
	ON_BN_CLICKED(IDC_GLOBAL_REFLECTION, OnBnClickedGlobalReflection)
	ON_BN_CLICKED(IDC_CLOSE_REGION, OnBnClickedCloseRegion)
	ON_BN_CLICKED(IDC_CLEAR_REGION, OnBnClickedClearRegion)
	ON_EN_KILLFOCUS(IDC_WEIGHT_INTERPOLATION, OnEnKillfocusWeightInterpolation)
	ON_NOTIFY(UDN_DELTAPOS, IDC_WEIGHT_INTERPOLATION_SPIN, OnDeltaposWeightInterpolationSpin)
	ON_EN_KILLFOCUS(IDC_IMG_SMOOTH_EDGEFIELD, OnEnKillfocusImgSmoothEdgefield)
	ON_NOTIFY(UDN_DELTAPOS, IDC_IMG_SMOOTH_EDGEFIELD_SPIN, OnDeltaposImgSmoothEdgefieldSpin)
	ON_EN_KILLFOCUS(IDC_STRONG_VERTEX_RATIO, OnEnKillfocusStrongVertexRatio)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STRONG_VERTEX_RATIO_SPIN, OnDeltaposStrongVertexRatioSpin)
	ON_BN_CLICKED(IDC_COMPUTE_EDGEFIELD_FROM_IMAGE, OnBnClickedComputeEdgeFieldFromImage)
	ON_BN_CLICKED(IDC_ZEROFIELD, &TabContent0::OnBnClickedZerofield)
	ON_BN_CLICKED(IDC_HEATDIFFUSION, &TabContent0::OnBnClickedHeatdiffusion)
	ON_BN_CLICKED(IDC_USE_INITIAL_FIELD, &TabContent0::OnBnClickedUseInitialField)
	ON_BN_CLICKED(IDC_APPLY_TRANSFORMATION, &TabContent0::OnBnClickedApplyTransformation)
END_MESSAGE_MAP()


void TabContent0::OnOK() {}
void TabContent0::OnCancel() {}

void TabContent0::initializeValues() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	reinterpret_cast<CButton*>(GetDlgItem(IDC_EDIT_ELEMENT))->SetCheck(1);


	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_IMG_SMOOTH_EDGEFIELD)), init_img_smoothing_for_edgefield_range);
	visview->setImgSmoothingIterationsForEdgeField(init_img_smoothing_for_edgefield_range);

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_EDGE_FIELD_SMOOTHING)), init_edge_field_smoothing_val);
	visview->setEdgeFieldSmoothingIterations(init_edge_field_smoothing_val);

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_GLOBAL_ROTATION)), init_global_rotation_val);
	visview->setGlobalRotationAngle(init_global_rotation_val);

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WEIGHT_INTERPOLATION)), init_weight_interpolation, weight_interpolation_prec);
	visview->setInterpolateWeight(init_weight_interpolation);

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STRONG_VERTEX_RATIO)), visview->strong_vertex_ratio, 3);


	updateRegionOption();

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}



/*
	Doesn't work properly on edge field if temporal smoothing is turned on
*/
void TabContent0::OnEnKillfocusEdgeFieldSmoothing() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_EDGE_FIELD_SMOOTHING));
	int val = (int)::getNumberFromCEdit(ce);

	val = (int)::clampVal(val, edge_field_smoothing_range[0], edge_field_smoothing_range[1]);	
	::setNumberToCEdit(ce, val);

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setEdgeFieldSmoothingIterations(val);

	switch(parent->getFileLoadStatus()) {
		case parent->IMAGE_LOADED:
			parent->setEdgeFieldForImage();
			break;

		case parent->VIDEO_LOADED:
			parent->setEdgeFieldForVideo();
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}




/*
	Doesn't work properly on edge field if temporal smoothing is turned on
*/
void TabContent0::OnDeltaposEdgeFieldSmoothingSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_EDGE_FIELD_SMOOTHING));
	int val = (int)::getNumberFromCEdit(ce);


	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = (int)::clampVal(val + delta, edge_field_smoothing_range[0], edge_field_smoothing_range[1]);	
	::setNumberToCEdit(ce, val);

	OnEnKillfocusEdgeFieldSmoothing();

	*pResult = 0;
}


void TabContent0::OnDeltaposGlobalRotationSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_GLOBAL_ROTATION));
	int val = (int)::getNumberFromCEdit(ce);

	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = (int)::clampVal(val + delta, global_rotation_range[0], global_rotation_range[1]);

	::setNumberToCEdit(ce, val);
	OnEnKillfocusGlobalRotation();

	*pResult = 0;
}


void TabContent0::OnEnKillfocusGlobalRotation() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_GLOBAL_ROTATION));
	int val = (int)::getNumberFromCEdit(ce);

	val = (int)::clampVal(val, global_rotation_range[0], global_rotation_range[1]);

	::setNumberToCEdit(ce, val);

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setGlobalRotationAngle(val);
	visview->global_rotate_field();
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}

void TabContent0::OnBnClickedAddRegularElement() { 
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_REGULAR_ELEMENT);
}
void TabContent0::OnBnClickedAddSource() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_SOURCE);
}

void TabContent0::OnBnClickedAddSink() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_SINK);
}

void TabContent0::OnBnClickedAddCcwCenter() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_CCW_CENTER);
}

void TabContent0::OnBnClickedAddCwCenter() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_CW_CENTER);
}

void TabContent0::OnBnClickedAddSaddle() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_SADDLE);
}

void TabContent0::OnBnClickedAddDipole1() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_DIPOLE1);
}

void TabContent0::OnBnClickedAddDipole2() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_DIPOLE2);
}

void TabContent0::OnBnClickedAddMonkeySaddle() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->ADD_MONKEY_SADDLE);
}

void TabContent0::OnBnClickedEditElement() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->EDIT_ELEMENT);
}

void TabContent0::OnBnClickedRemoveElement() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->REMOVE_ELEMENT);
}

void TabContent0::OnBnClickedSingularityPairCancellation() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->SINGULARITY_PAIR_CANCELLATION);
}

void TabContent0::OnBnClickedMoveSingularity() {
	VisView *visview = parent->getVisView();

	visview->setActionState(visview->MOVE_SINGULARITY);
}

void TabContent0::OnBnClickedFlowSmoothing() { }	// <--???


void TabContent0::OnBnClickedSetZero() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->resetField();
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnBnClickedGlobalReflection() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->global_reflect_field();
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnBnClickedCloseRegion() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	prev_timer_status = visview->getDisplayTimerStatus();
	
	visview->stopDisplayTimer();
	visview->smoothClosedField();
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnBnClickedClearRegion() {
	parent->getVisView()->clearSelectedRegion();
}


void TabContent0::OnEnKillfocusWeightInterpolation() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_WEIGHT_INTERPOLATION));
	double val = ::getNumberFromCEdit(ce);

	val = ::clampVal(val, weight_interpolation_range[0], weight_interpolation_range[1]);

	::setNumberToCEdit(ce, val, weight_interpolation_prec);

	prev_timer_status = visview->getDisplayTimerStatus();
	
	visview->stopDisplayTimer();
	visview->setInterpolateWeight(val);
	visview->interpolateField();
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnDeltaposWeightInterpolationSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	double delta = 0.1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_WEIGHT_INTERPOLATION));
	double val = ::getNumberFromCEdit(ce);

	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = ::clampVal(val + delta, weight_interpolation_range[0], weight_interpolation_range[1]);

	::setNumberToCEdit(ce, val, weight_interpolation_prec);
	OnEnKillfocusWeightInterpolation();

	*pResult = 0;
}


void TabContent0::OnEnKillfocusImgSmoothEdgefield() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_IMG_SMOOTH_EDGEFIELD));
	int val = (int)::getNumberFromCEdit(ce);

	val = (int)::clampVal(val, img_smoothing_for_edgefield_range[0], img_smoothing_for_edgefield_range[1]);

	::setNumberToCEdit(ce, val);

	prev_timer_status = visview->getDisplayTimerStatus();
	
	visview->stopDisplayTimer();
	visview->setImgSmoothingIterationsForEdgeField(val);

	switch(parent->getFileLoadStatus()) {
		case parent->IMAGE_LOADED:
			parent->setEdgeFieldForImage();
			break;

		case parent->VIDEO_LOADED:
			parent->setEdgeFieldForVideo();
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnDeltaposImgSmoothEdgefieldSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_IMG_SMOOTH_EDGEFIELD));
	int val = (int)::getNumberFromCEdit(ce);

	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = (int)::clampVal(val + delta, img_smoothing_for_edgefield_range[0], img_smoothing_for_edgefield_range[1]);

	::setNumberToCEdit(ce, val);
	OnEnKillfocusImgSmoothEdgefield();

	*pResult = 0;
}


void TabContent0::OnEnKillfocusStrongVertexRatio()
{
	bool prev_timer_status;
	int prec = 3;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STRONG_VERTEX_RATIO));
	double val = ::getNumberFromCEdit(ce);

	val = ::clampVal(val, 0, 1);

	::setNumberToCEdit(ce, val, prec);

	prev_timer_status = visview->getDisplayTimerStatus();
	
	visview->stopDisplayTimer();
	visview->strong_vertex_ratio = val;

	switch(parent->getFileLoadStatus()) {
		case parent->IMAGE_LOADED:
			parent->setEdgeFieldForImage();
			break;

		case parent->VIDEO_LOADED:
			parent->setEdgeFieldForVideo();
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnDeltaposStrongVertexRatioSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	double delta = 0.01;
	int prec = 3;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STRONG_VERTEX_RATIO));
	double val = ::getNumberFromCEdit(ce);

	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = ::clampVal(val + delta, 0, 1);

	::setNumberToCEdit(ce, val, prec);
	OnEnKillfocusStrongVertexRatio();

	*pResult = 0;
}


void TabContent0::OnBnClickedComputeEdgeFieldFromImage() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->resetField();
	visview->computeFieldFromImage();
	visview->constructFieldInformation();
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnBnClickedZerofield() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	PaintingRegion *selected = visview->getSelectedRegion();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if(selected == NULL) {
	}
	else {
		selected->setUseZeroField(!selected->getUseZeroField());
	}

	visview->clearField();
	visview->initializeRendering();	

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnBnClickedHeatdiffusion() {}


void TabContent0::OnBnClickedUseInitialField() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CButton *b = reinterpret_cast<CButton*>(GetDlgItem(IDC_USE_INITIAL_FIELD));

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if(visview->getSelectedRegion() != NULL) {
		visview->getSelectedRegion()->setUseZeroField((b->GetCheck() == 0) ? true : false);
		visview->updateRegionInfoOnMesh();
		visview->initializeRendering();
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::OnBnClickedApplyTransformation() {
	bool prev_timer_status;
	PaintingRegion *r = NULL;
	VisView *visview = parent->getVisView();
	CButton *b = reinterpret_cast<CButton*>(GetDlgItem(IDC_APPLY_TRANSFORMATION));


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if((r = visview->getSelectedRegion()) != NULL) {
		r->setApplyTransformation((b->GetCheck() == 1) ? true : false);
		visview->resetPropagation();				// recompute design elements (for all regions...)
		visview->updateRegionInfoOnMesh();
		visview->initializeRendering();
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent0::updateRegionOption() {
	VisView *visview = parent->getVisView();
	PaintingRegion *r = NULL;
	CButton *b1 = reinterpret_cast<CButton*>(GetDlgItem(IDC_USE_INITIAL_FIELD));
	CButton *b2 = reinterpret_cast<CButton*>(GetDlgItem(IDC_APPLY_TRANSFORMATION));


	if(visview != NULL) {
		r = visview->getSelectedRegion();

		if(r == NULL) {
			b1->EnableWindow(FALSE);
			b2->EnableWindow(FALSE);
		}
		else {
			b1->EnableWindow(TRUE);
			b2->EnableWindow(TRUE);

			b1->SetCheck((r->getUseZeroField() == false) ? 1 : 0);
			b2->SetCheck((r->getApplyTransformation() == true) ? 1 : 0);
		}
	}
}

