#pragma once
#include "Resource.h"
#include "PaintingPreset.h"
#include "MFCTEST4Dlg.h"
#include "VisView.h"


// Forward Declaration
class CMFCTEST4Dlg;


// TabContent1 dialog

class TabContent1 : public CDialog
{
	DECLARE_DYNAMIC(TabContent1)

public:
	TabContent1(CMFCTEST4Dlg* pParent = NULL);
	virtual ~TabContent1();
	void initializeValues();

// Dialog Data
	enum { IDD = IDD_DIALOG1 };


private:
	CMFCTEST4Dlg *parent;
	CDialog *option_dlg;

	int selected_vec_composition_method;
	int selected_ten_composition_method;



public:
	const static int num_display_mode = 9;
	static LPCSTR display_mode[];

	const static int num_tensor_vis_type = 3;
	static LPCSTR tensor_vis_type[];

	const static int num_vec_img_composition_methods = 2;
	static LPCSTR vec_img_composition_methods[];

	const static int num_ten_img_composition_methods = 12;
	static LPCSTR ten_img_composition_methods[];

	const static int num_color_composition_methods = 2;
	static LPCTSTR color_composition_methods[num_color_composition_methods];

	const static int num_style_interpolations = 7;
	static LPCTSTR style_interpolations[num_style_interpolations];

	const static int default_prec = 1;
	const static int displacement_prec = 4;
	const static int hsv_sv_prec = 2;

	const static int num_NPN_type = 2;
	static LPCTSTR NPN_type[];					// 128, 256

	const static int num_noise_type = 2;
	static LPCTSTR noise_type[];

	const static int num_post_processing_operations = 2;
	static LPCTSTR post_processing_operation[];

	const static int num_sorting_options = 2;
	static LPCTSTR sorting_options[];

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	virtual void OnCancel();

	DECLARE_MESSAGE_MAP()

	void enableWindowsOnWarpingSetting(int idx);
	void enableWindowsOnRenderer(BOOL val);
	void enableWindowsOnStrokes(BOOL val);
	void enableWindowsOnLayering(BOOL val);
	void enableWindowsOnStrokeOrdering(BOOL val);
	void enableWindowsOnPostProcessing(BOOL val);
	void enableWindowsOnStyleInterpolation(BOOL val);
	void updatePostProcessingCaptions(int idx);


	void loadPaintingPreset(const PaintingPreset &preset);

public:
	void updatePaintingPresetParameters();
	void setStrokeOrderInfoText();
	void updateStyleInterpolationCombo();


	afx_msg void OnBnClickedOk();

	/* IBFV general setting */
	afx_msg void OnCbnSelchangeDisplayMode();
	afx_msg void OnCbnSelchangeTensorVisMode();
	afx_msg void OnCbnSelchangeImageCompositionMethod();
	afx_msg void OnEnKillfocusDisplacement();
	afx_msg void OnDeltaposDisplacementSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusBgImgBlend();
	afx_msg void OnDeltaposBgImgBlendSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnCbnSelchangeColorCompositionMethod();
	afx_msg void OnEnKillfocusNumIterations();
	afx_msg void OnDeltaposNumIterationsSpin(NMHDR *pNMHDR, LRESULT *pResult);


	/* IBFV noise setting */
	afx_msg void OnCbnSelchangeNpn();


	/* IBFV painting setting */

	// renderer
	afx_msg void OnBnClickedSelectRenderer();


	// strokes options
	afx_msg void OnDeltaposNoiseAmplitudeSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusNoiseAmplitude();
	afx_msg void OnDeltaposStrokeDisplacementSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeDisplacement();
	afx_msg void OnDeltaposStrokeParam1Spin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeParam1();
	afx_msg void OnDeltaposStrokeAmountSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeAmount();
	afx_msg void OnDeltaposStrokePositionJitterSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokePositionJitter();
	afx_msg void OnDeltaposStrokeOpacitySpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeOpacity();
	afx_msg void OnDeltaposStrokeMinLengthSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeMinLength();
	afx_msg void OnDeltaposStrokeMaxLengthSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeMaxLength();
	afx_msg void OnDeltaposStrokeAmbientHSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeAmbientH();
	afx_msg void OnDeltaposStrokeAmbientSSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeAmbientS();
	afx_msg void OnDeltaposStrokeAmbientVSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrokeAmbientV();
	afx_msg void OnCbnSelchangeStyleInterpolationSelectionCombo();


	// layering
	afx_msg void OnEnKillfocusAreaError();
	afx_msg void OnDeltaposAreaError(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusNumLayers();
	afx_msg void OnDeltaposNumLayersSpin(NMHDR *pNMHDR, LRESULT *pResult);


	// stroke ordering
	afx_msg void OnBnClickedSelectStrokeOrder();
	afx_msg void OnBnClickedColorOrderOption();
	afx_msg void OnCbnSelchangeSortingOption();


	// Post processing
	afx_msg void OnBnClickedEnablePostProcessing();
	afx_msg void OnCbnSelchangePostProcessingOperation();
	afx_msg void OnBnClickedSelectEmbossingType();
	afx_msg void OnEnKillfocusPostProcessParam1();
	afx_msg void OnEnKillfocusPostProcessParam2();
	afx_msg void OnEnKillfocusPostProcessParam3();
	afx_msg void OnEnKillfocusPostProcessParam4();
	afx_msg void OnDeltaposPostProcessParam1Spin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposPostProcessParam2Spin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposPostProcessParam3Spin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposPostProcessParam4Spin(NMHDR *pNMHDR, LRESULT *pResult);


	/* Painting presets */
	afx_msg void OnBnClickedResetPainting();
	afx_msg void OnBnClickedSetPreset();
	afx_msg void OnBnClickedRemovePreset();
	afx_msg void OnBnClickedPresetWatercolor();
	afx_msg void OnBnClickedPresetPointillism();
	afx_msg void OnBnClickedPresetFracture2();
	afx_msg void OnBnClickedPresetVangoghSP();
	afx_msg void OnBnClickedPresetImpressionismSP();
	afx_msg void OnBnClickedPresetColorwashSP();


	/* Manual segmentation */
	afx_msg void OnBnClickedSelectTraceMode();
	afx_msg void OnBnClickedShowCurves();


	/* Debug... */
	afx_msg void OnEnKillfocusTestEdit();
	afx_msg void OnDeltaposTestEditSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusGapThreshold();
	afx_msg void OnDeltaposGapThresholdSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnShowinput();
	afx_msg void OnShowopt();
	afx_msg void OnShowpainting();
	afx_msg void OnShowseg();
	afx_msg void OnShowtensor();
	afx_msg void OnShowvec();
};
